
/*---------------------------------------------------------------------------
      Chapter 8: Intelligent techniques of Logic Programming (Paragraph 8.1)
      This code is part of the book
      LOGIC PROGRAMMING TECHNIQUES: THE PROLOG LANGUAGE
      Ilias Sakellariou, Nikos Bassiliades, Petros Kefalas, Demosthenes Stamatis
      Hellenic Academic On-line Publications, 2015
    ----------------------------------------------------------------------------*/
    
/* Implementing insert by the use of delete */
list_insert(X,L,LN):-
  list_delete(X,LN,L).

/* Implementing member by the use of append */
list_member2(X,L):- 
  list_append(_,[X|_],L).

/* Implementing delete by the use of append */
list_delete2(X,L1,L2):-
  list_append(A,[X|B],L1),
  list_append(A,B,L2).

/* Implementing member by the use of delete */
list_member3(X,L):- 
 list_delete(X,L,_).

list_member(X,[X|_]).
list_member(X,[_|Tail]):-
  list_member(X,Tail). 

list_delete(X,[X|Tail],Tail).
list_delete(X,[Y|Tail],[Y|List]):-
     list_delete(X,Tail,List).

list_append([],List2,List2).
list_append([X|Tail],List2,[X|List3]):-
  list_append(Tail,List2,List3). 

