
/*---------------------------------------------------------------------------
      Chapter 8: Intelligent techniques of Logic Programming (Paragraph 8.1)
      This code is part of the book
      LOGIC PROGRAMMING TECHNIQUES: THE PROLOG LANGUAGE
      Ilias Sakellariou, Nikos Bassiliades, Petros Kefalas, Demosthenes Stamatis
      Hellenic Academic On-line Publications, 2015
    ----------------------------------------------------------------------------*/
    
/* A "small' dictionnary  */

word([h,e,l,l,o]).
word([m,a,n]).
word([m,e,n]).
word([w,o,m,a,n]).
word([b,o,o,k]).
word([m,o,t,h,e,r]).
word([c,o,m,p,u,t,e,r]).
word([c,a,r]).
word([p,r,o,l,o,g]).
word([p,e,n,c,i,l]).
word([t,a,b,l,e]).

/* Rules for spellchecking  */

changeletter(Word,CorrectWord) :-
  append(Begin,[Letter|End],Word),
  word(CorrectWord),
  append(Begin,[NewLetter|End],CorrectWord),
  NewLetter\= Letter.

swapletters(Word, CorrectWord) :-
  append(Begin, [Letter1,Letter2|End], Word),
  word(CorrectWord),
  append(Begin, [Letter2,Letter1|End], CorrectWord),
  Letter1 \= Letter2.

exchangeletters(Word, CorrectWord) :-
  append(Begin, [Letter1|Rest], Word),
  append(Middle, [Letter2|End], Rest),
  word(CorrectWord),
  append(Middle, [Letter1|End], NewRest),
  append(Begin, [Letter2|NewRest], CorrectWord),
  Letter1 \= Letter2.

movefront(Word, CorrectWord) :-
  append(Begin, Rest, Word),
  append(Middle, [Letter|End], Rest),
  word(CorrectWord),
  append([Letter|Middle], End, NewRest),
  append(Begin, NewRest, CorrectWord).

delete2letters(Word, CorrectWord) :-
  list_append(Begin, [Letter1|Rest], Word),
  list_append(Middle, [Letter2|End], Rest),
  word(CorrectWord),
  list_append(Middle, End, NewRest),
  list_append(Begin, NewRest, CorrectWord).


